'vector/matrix classes by Dr_D

'#include once "chipmunk/chipmunk.bi"
#include once "crt/string.bi"
#include once "raylib.bi"

namespace nmathf

#define use_double 1

#ifdef use_double 
 	
 	#define mFloat double
 		
	#else
 
	#define mFloat single
 
#endif

	

const as mFloat pi = 3.1415926, pi2 = pi*2f, pi_half = pi/2f, pi_4th = pi/4f, pi_8th = pi/8f, pi_180 = pi/180f, inv_pi_180 = 180f/pi, pi_360 = pi/360f
const as integer Sphere_Intersects = 1, Sphere_Front = 2, Sphere_Behind = 3
const as integer MAT_COPY_SIZE = 16 * sizeof(mFloat)


type matrix_ as matrix4x4


type vec2f

	declare constructor ( byval x as mFloat, byval y as mFloat )
	declare constructor ( byref v2d as vec2f )
	'declare constructor ( byref v2d as cpVect )
	declare constructor ( )
	
	x as mFloat
	y as mFloat

	declare operator cast() as string
	
	'declare operator cast() as cpVect
   'declare operator cast() as cpVect ptr
	'declare operator let( byref v as cpVect )
	
	
	declare function dot ( byref v as vec2f ) as mFloat
	declare function magnitude() as mFloat
	declare sub normalize()
	declare function UnitVec() as vec2f
	declare function cross( byref v as vec2f ) as vec2f
	declare function cross_analog( byref v as vec2f ) as mFloat
	declare function distance( byref v as vec2f ) as mFloat
	declare function AngleBetween( byref v as vec2f ) as mFloat

end type


type vec3f

	declare constructor ( byval x as mFloat, byval y as mFloat, byval z as mFloat )
	declare constructor ( byref v3d as vec3f )
	declare constructor ( )

	x as mFloat
	y as mFloat
	z as mFloat

	declare operator Cast() as string
	declare operator Cast() as vec2f
	declare operator *= ( byref rhs as matrix_ )
	declare operator *= ( byref s as mFloat )

	declare operator +=( byref rhs as vec3f )

	declare function dot ( byref v as vec3f ) as mFloat
	declare function magnitude() as mFloat
	declare sub normalize()
	declare function UnitVec() as vec3f
	declare function cross( byref v as vec3f ) as vec3f
	declare function distance( byref v as vec3f ) as mFloat
	declare function AngleBetween( byref v as vec3f ) as mFloat

end type


type vec4f

	declare constructor ( byval x as mFloat, byval y as mFloat, byval z as mFloat, byval w as mFloat )
	declare constructor ( byref v4d as vec4f )
	declare constructor ( )

	x as mFloat
	y as mFloat
	z as mFloat
	w as mFloat

	declare operator Cast() as string
	declare operator Cast() as vec3f
	declare operator *= ( byref rhs as matrix_ )
	declare operator *= ( byref s as mFloat )
	
	declare operator let ( byref rhs as vec3f )
	
	declare function dot ( byref v as vec4f ) as mFloat
	declare function magnitude() as mFloat
	declare sub normalize()
	declare function UnitVec() as vec4f
	declare function cross( byref v as vec4f ) as vec4f
	declare function distance ( byref v as vec4f ) as mFloat

end type


declare operator + ( byref lhs as vec2f, byref rhs as mFloat ) as vec2f
declare operator + ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator = (byref lhs as vec2f, byref rhs as vec2f ) as integer


declare operator + ( byref lhs as vec3f, byref rhs as mFloat ) as vec3f
declare operator + ( byref lhs as vec3f, byref rhs as vec3f ) as vec3f

declare operator + ( byref lhs as vec4f, byref rhs as vec4f ) as vec4f
declare operator + ( byref lhs as vec4f, byref rhs as mFloat ) as vec4f

declare operator - ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f

declare operator - ( byref lhs as vec3f ) as vec3f
declare operator - ( byref lhs as vec3f, byref rhs as vec3f ) as vec3f
declare operator - ( byref lhs as vec3f, byref rhs as vec4f ) as vec3f
declare operator - ( byref lhs as vec3f, byref rhs as mFloat ) as vec3f

declare operator - ( byref lhs as vec4f, byref rhs as vec4f ) as vec4f
declare operator - ( byref lhs as vec4f ) as vec4f

declare operator * ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator * ( byref lhs as vec2f, byref rhs as mFloat ) as vec2f

declare operator * ( byref lhs as vec3f, byref rhs as vec3f ) as vec3f
declare operator * ( byref lhs as vec3f, byref rhs as vec4f ) as vec3f
declare operator * ( byref lhs as vec3f, byref rhs as double ) as vec3f


declare operator * ( byref lhs as vec4f, byref rhs as vec4f ) as vec4f
declare operator * ( byref lhs as vec4f, byref rhs as mFloat ) as vec4f



declare operator / ( byref lhs as vec2f, byref rhs as vec2f ) as vec2f
declare operator / ( byref lhs as vec2f, byref rhs as integer  ) as vec2f
declare operator / ( byref lhs as vec2f, byref rhs as mFloat   ) as vec2f



declare operator / ( byref lhs as vec3f, byref rhs as vec3f ) as vec3f
declare operator / ( byref lhs as vec3f, byref rhs as mFloat ) as vec3f



declare operator / ( byref lhs as vec4f, byref rhs as vec4f ) as vec4f
declare operator / ( byref lhs as vec4f, byref rhs as mFloat ) as vec4f




type vmat
	r as vec3f
	u as vec3f
	f as vec3f
	p as vec3f
	
	declare constructor()
	declare constructor( byref r as vec3f, byref u as vec3f, byref f as vec3f, byref p as vec3f )
	
	declare sub rotate( byval x as mFloat, byval y as mFloat, byval z as mFloat )
	
end type



type matrix4x4

	public:

	declare constructor( byref c as mFloat = 0)
	declare constructor( byref r as vec3f, byref u as vec3f, byref f as vec3f, byref p as vec3f )
	declare constructor( byref x as matrix4x4 )
	declare sub LoadIdentity()
	declare sub LookAt( byref v1 as vec3f, byref v2 as vec3f, byref vup as vec3f )
	declare sub PointAt( byref v1 as vec3f, byref v2 as vec3f )
	declare function Inverse() as matrix4x4
	declare function PlanarProjection( byref lightpos as vec4f, byref plane as vec4f ) as matrix4x4
	declare sub InfiniteProjection( byref fov as mFloat, byref aspect as mFloat, byref znear as mFloat )
	declare sub Perspective( byval fov as mFloat, byval aspect as mFloat, byval zNear as mFloat, byval zFar as mFloat )
	declare sub AxisAngle( byref v as vec3f, byref angle as mFloat )
	declare sub Translate( byref v as vec2f )
	declare sub Translate( byref v as vec3f )
	declare sub Translate( byref x as mFloat, byref y as mFloat, byref z as mFloat )
	declare sub Translate( byref x as integer, byref y as integer, byref z as integer )
	declare sub Rotate( byref v as vec3f )
	declare sub Rotate( byref anglex as mFloat, byref angley as mFloat, byref anglez as mFloat )
	declare sub Rotate( byref anglex as integer, byref angley as integer, byref anglez as integer )
	declare sub Scale( byref scalar as mFloat )
	declare sub Scale( byref scalarx as mFloat, byref scalary as mFloat, byref scalarz as mFloat )
	declare sub Gram_Schmidt( byref d as vec3f )

	declare property right( byref v as vec3f )
	declare property Up( byref v as vec3f )
	declare property Forward( byref v as vec3f )
	declare property Position( byref v as vec3f )

	declare property right( byref v as vec4f )
	declare property Up( byref v as vec4f )
	declare property Forward( byref v as vec4f )
	declare property Position( byref v as vec4f )

	declare property right() as vec4f
	declare property Up() as vec4f
	declare property Forward() as vec4f
	declare property Position() as vec4f
	declare property GetArrayData() as mFloat ptr
	
	declare function Rotation() as matrix4x4
	
	declare operator *= ( byref mat as matrix4x4 )
	declare operator cast() as string
	declare operator cast() as mFloat ptr
	declare operator cast() as vmat

	'private:
	m(15) as mFloat = any

end type

declare operator * ( byref lhs as matrix4x4, byref rhs as matrix4x4 ) as matrix4x4
declare operator * ( byref lhs as vec2f, byref rhs as matrix4x4 ) as vec2f
declare operator * ( byref lhs as vec3f, byref rhs as matrix4x4 ) as vec4f
declare operator * ( byref lhs as vec4f, byref rhs as matrix4x4 ) as vec4f

'for raylib
#define max( a, b ) iif( ( a ) > ( b ), ( a ), ( b ) )
#define min( a, b ) iif( ( a ) < ( b ), ( a ), ( b ) )
declare function ClampValue( value as Vector2, min_ as Vector2, max_ as Vector2 ) as Vector2

declare function inv_sqr( byval dist as mFloat ) as mFloat
declare function cotan( byref num as mFloat ) as mFloat
declare function poly_normal( byref V as vec3f ptr ) as vec3f
declare function plane_distance( byref tNormal as vec3f, byref tPoint as vec3f) as mFloat
declare function closestpointonline( byref Va as vec3f, byref Vb as vec3f, byref vPoint as vec3f ) as vec3f
declare function intersected_plane( byref V as vec3f ptr, byref vLine as vec3f ptr, byref vNormal as vec3f, byref OriginDist as mFloat) as integer
declare function intersection_point( byref vNormal as vec3f, byref vLine as vec3f ptr, byref tDistance as mFloat ) as vec3f
declare function point_inside_triangle3d( byref vPoint as vec3f, byref V as vec3f ptr ) as integer
declare function sameside( byref p1 as vec3f, byref p2 as vec3f, byref a as vec3f, byref b as vec3f ) as integer
declare function line_triangle_intersection( byref V as vec3f ptr, byref vLine as vec3f ptr, byref New_Intersection as vec3f ) as integer
declare sub get_collision_offset(byref vNormal as vec3f, byref Radius as mFloat, byref Dist as mFloat, byref vOffSet as vec3f)
declare function classify_sphere(byref vCenter as vec3f, byref VNormal as vec3f, byref vPoint as vec3f, byref Radius as mFloat, byref Dist as mFloat ) as integer
declare function edge_sphere_collision( byref vCenter as vec3f, byref V as vec3f ptr, byref Radius as mFloat ) as integer
declare function point_inside_triangle2d (  byref x as integer, byref y as integer, byref p1 as vec2f, byref p2 as vec2f, byref p3 as vec2f ) as integer
declare function AABB overload( byref a1 as vec2f, byref a2 as vec2f, byref b1 as vec2f, byref b2 as vec2f) as integer
declare function AABB overload( byref a1 as vec3f, byref a2 as vec3f, byref b1 as vec3f, byref b2 as vec3f) as integer
declare function PointInAABB( byref p as vec3f, byref b1 as vec3f, b2 as vec3f ) as integer
declare function Spline_Point( Points() as vec3f, byval p as mFloat ) as vec3f
declare function tri_plane( byref v1 as vec3f, byref v2 as vec3f, byref v3 as vec3f ) as vec4f	

end namespace
