#include once "mathfuncf.bi"
#include once "raylib.bi"

using nMathf

enum PARTICLE_ENUM

	EXPLOSION
	SHIELD
	THRUST
	PING

end enum


type rgb_struct

	as integer r, g, b, colour


	declare constructor()

	declare constructor( byref r as integer, byref g as integer, byref b as integer )

	declare constructor( byref nCol as rgb_struct )

	declare operator cast() as uinteger

end type



type particle_struct
	
	as vec2f p, v, targV, dirVec, collideP
	
	as byte active
	
	as mFloat rot, targRot, rotDelta
	
	as vec2f pb
	
	pType as PARTICLE_ENUM
	
	as mFloat size, sizeDelta, sizeMax, lSpan, vDecay
	
	as rgb_struct colour, colDelta
	
	as Texture2D sprite
	
end type


type particle_system
	
	parts( any ) as particle_struct
	
	declare sub render( byref cam as camera2D )
	declare sub init( byref cnt as integer )
	declare sub update( byref tDelta as mFloat )
	declare sub spawn_shield( byref sp as vec2f, byref ep as vec2f, byref vel as vec2f )	
	declare sub spawn_explosion( byref posit as vec2f, byref mag as mFloat, byref maxParts as integer = 19, byref partType as PARTICLE_ENUM, byref sprite as Texture2D, byref lifeSpan as mFloat )
	declare sub spawn_ping( byref posit as vec2f, byref radDelta as mFloat, byref ang as mFloat, byref partType as PARTICLE_ENUM )
	declare sub spawn_thrust( byref posit as vec2f, byref vel as vec2f, byref ang as mFloat, byref sprite as Texture2D, byref lifeSpan as mFloat)
	
end type
