#include once "raylib.bi"
#include once "raymath.bi"
#include once "particle.bi"
#include once "sound.bi"

type block_struct
	
	as color			fclr
	
	as color			bClr
	
	as byte			ID
	
end type


type shape_struct
	
	as integer			shapeID
	
	as block_struct	block(3,3)

	declare function rotateCCW() as integer
	declare function rotateCW()  as integer
	declare function copy( oShape as shape_struct ) as integer
	
end type


type world_struct
	
	as integer 				playerID
	
	as integer				score
	
	as integer				level
	
	as integer				levCount
	
	as integer 				gridSizeX = 20
	
	as integer 				gridSizeY = 30 
	
	as integer 				gridPosX=1280/2-200
	
	as integer 				gridPosY = 60
	
	as byte 					isPaused = false
	
	as byte 					checkLines
	
	as Font 					fontTtf
	
	as integer 				windowWidth = 1280
	as integer 				windowHeight = 720
	as integer 				gameScreenWidth = 640
	as integer 				gameScreenHeight = 480
	as mFloat				screenScale
	
	as Texture2D			texture
	
	as texture2D			explosionTexture
	
	as image					colorMapTexture
	
	as Camera2D				camera
	
	as RenderTexture2D 	screenBuffer
	
	as particle_system	particles
		
	as sound_system		soundSys
	
	as integer				soundIndex(any)		
	
	as block_struct		grid( any, any )
	
	as shape_struct     	baseShape(6)
	
	as shape_struct		curShape
	
	as shape_struct		nextShape
	
	as integer				destructMark(3)
	
	as integer				destructCount
	
	as double				destructTimer
	
	as integer				curShapePosX
	
	as integer				oldCurShapePosY
	
	as integer				curShapePosY
	
	declare function gen_random_part( isFirstPart as integer ) as integer
	
	declare function init( byref windowWidth as integer, byref windowHeight as integer ) as integer
	
	declare function update( byref deltaTime as double, byref curTime as double ) as integer	
	
	declare function render() as integer
	
	declare function terminate() as integer
	
	declare function copy_temp_to_main() as integer
	
	declare function copy_main_to_temp() as integer
	
	declare function add_cur_piece_to_main( curPieceID as integer, curPosX as integer, curPosY as integer ) as integer
	
	declare function new_level() as integer
	
	declare function check_lines() as integer
	
	declare function remove_lines() as integer
	
	declare function check_left_move() as integer
	
	declare function check_right_move() as integer
	
end type




'block data
data 0,2,0,0
data 0,2,2,0
data 0,0,2,0
data 0,0,0,0

data 0,0,2,0
data 0,2,2,0
data 0,2,0,0
data 0,0,0,0

data 0,2,0,0
data 0,2,0,0
data 0,2,0,0
data 0,2,0,0

data 0,2,0,0
data 0,2,0,0
data 0,2,2,0
data 0,0,0,0

data 0,0,2,0
data 0,0,2,0
data 0,2,2,0
data 0,0,0,0

data 0,0,0,0
data 0,2,2,2
data 0,0,2,0
data 0,0,0,0

data 0,0,0,0
data 0,2,2,0
data 0,2,2,0
data 0,0,0,0
