randomize timer
#include once "main.bi"

dim world as world_struct

dim as double curTime, deltaTime, accumTime, dropTime = 1.5, keyTime, keyRepeatDelayTime = .04

with world

	.init(1280, 720)
	.new_level()
	.gen_random_part( true )
	.curShapePosX = .gridSizeX \ 2

	var listPos = vec2f(0,0)

	.soundSys.load_wav( "res/sfx/snd/flip.wav" )
	.soundSys.load_wav( "res/sfx/snd/move.wav" )
	.soundSys.load_wav( "res/sfx/snd/set.wav" )
	.soundSys.load_wav( "res/sfx/snd/line.wav" )
	.soundSys.load_wav( "res/sfx/snd/full.wav" )
	.soundSys.load_wav( "res/sfx/snd/crash.wav" )

	.soundIndex(0) = .soundSys.add_source( 0, 1, "Flip" )
	.soundIndex(1) = .soundSys.add_source( 1, 1, "Move" )
	.soundIndex(2) = .soundSys.add_source( 2, 1, "Set" )
	.soundIndex(3) = .soundSys.add_source( 3, 1, "Line" )
	.soundIndex(4) = .soundSys.add_source( 4, 1, "Full" )
	.soundIndex(5) = .soundSys.add_source( 5, 1, "Crash" )


	dim as integer theme = world.soundSys.load_song( "res/sfx/mus/Glass Room.mp3" )
	'world.soundSys.play_song( theme, 1 )
	fbs_Set_MasterVolume( 1)

	.soundSys.set_listener_position( listPos )


	do

		.oldCurShapePosY = .curShapePosY

		deltaTime = timer - curTime
		curTime = timer

		if IsKeyPressed( KEY_P ) then

			.isPaused = not .isPaused

		end if

		if .checkLines = 0 and not .isPaused then

			accumTime+=deltaTime
			if accumTime>dropTime then

				.curShapePosY+=1

				accumTime = 0

			end if

			if IsKeyDown( KEY_LEFT ) then

				if curTime>keyTime then

					keyTime = curTime + keyRepeatDelayTime

					if .check_left_move() then

						.curShapePosX-=1
						.soundSys.set_source_position( .soundIndex(1), vec2f(0,0) )
						.soundSys.play_source( .soundIndex(1), 1 )

					end if

				end if

			end if

			if IsKeyDown( KEY_RIGHT ) then

				if curTime>keyTime then

					keyTime = curTime + keyRepeatDelayTime

					if .check_right_move() then

						.curShapePosX+=1
						.soundSys.set_source_position( .soundIndex(1), vec2f(0,0) )
						.soundSys.play_source( .soundIndex(1), 1 )

					end if

				end if

			end if


			if IsKeyPressed( KEY_UP ) then

				dim as integer allGood = true

				dim as shape_struct tShape
				tShape.copy(.curShape)
				tShape.rotateCW()

				for y as integer = 0 to 3

					for x as integer = 0 to 3

						if tShape.block(x,y).ID = 0 then continue for

						if .grid(x+.curShapePosX, y+.curshapePosY).ID <> 0 then

							allGood = false

						end if

					next

				next

				if allGood then

					.curShape.rotateCW()

					.soundSys.set_source_position( .soundIndex(0), vec2f(0,0) )
					.soundSys.play_source( .soundIndex(0), 1 )

				end if

			end if


			if IsKeyDown( KEY_DOWN ) then

				accumTime = dropTime

			end if

		end if


		for y as integer = 0 to 3

			for x as integer = 0 to 3

				if .curShape.block(x, y).ID = 0 then continue for

				if .grid(x+.curShapePosX, y+.curshapePosY).ID <> 0 then

					if y+.curShapePosY >= 2 then

						.add_cur_piece_to_main( .curShape.shapeID, .curShapePosX, .oldCurShapePosY )

						.soundSys.set_source_position( .soundIndex(2), vec2f(0,0) )
						.soundSys.play_source( .soundIndex(2), 1 )

						.curShapePosY = 0
						.curShapePosX = .gridSizeX / 2
						.gen_random_part( false )

						.checkLines = 1

						exit for, for

					end if

				end if

			next

		next


		if .checkLines = 1 then

			.destructCount = .check_lines()

			if .destructCount > 0 and .destructCount < 4 then

				.soundSys.set_source_position( .soundIndex(3), vec2f(0,0) )
				.soundSys.play_source( .soundIndex(3), 1 )
				.checkLines = 2
				.destructTimer = curTime + 1

			elseif .destructCount = 4 then

				.soundSys.set_source_position( .soundIndex(4), vec2f(0,0) )
				.soundSys.play_source( .soundIndex(4), 1 )
				.checkLines = 2
				.destructTimer = curTime + 1

			else

				if .oldCurShapePosY<= 0 then

					.new_level()
					.gen_random_part( true )
					.curShapePosX = .gridSizeX \ 2
					.Score = 0
					dropTime = 1.5
					.level = 0

				end if

				.checkLines = 0
				.destructTimer = 0
				.destructCount = 0

			end if

		elseif .checkLines = 2 then

			if timer>=.destructTimer then

				select case as const .destructCount

					case 1
						.Score+=100
						.levCount+=1
					case 2
						.Score+=200
						.levCount+=2
					case 3
						.Score+=400
						.levCount+=3
					case 4
						.Score+=1600
						.levCount+=4
				end select

				if .levCount >= 10 then

					.levCount=0
					.level+=1
					dropTime -= .05

					if dropTime < 0 then

						dropTime = 0

					end if

				end if
				
				for i as integer = 0 to .destructCount-1

					dim as integer y = .destructMark(i)

					for x as integer = 1 to .gridSizeX-1

						.particles.spawn_explosion( vec2f(x*20+.gridPosX+10, y*20+.gridPosY+10), 3, 20, PARTICLE_ENUM.EXPLOSION, .explosionTexture, curTime+2)

					next

				next
				
				.soundSys.set_source_position( .soundIndex(5), vec2f(0,0) )
				.soundSys.play_source( .soundIndex(5), 1 )
				.remove_lines()
				.checkLines = 0
				.destructCount = 0
				.destructTimer = 0

			end if


		end if


		BeginDrawing()

		ClearBackground( BLACK )
		DrawText( "Score " & .Score, 10, 10, 20, DARKGRAY )
		DrawText( "Level " & .Level, 10, 30, 20, DARKGRAY )

		for y as integer = 0 to .gridSizeY

			for x as integer = 0 to .gridSizeX

				if .grid(x,y).ID > 0 then

					DrawRectangle( (x*20) + .gridPosX, (y*20) + .gridPosY, 20, 20, .grid(x,y).bclr )
					DrawRectangleLines( (x*20) + .gridPosX, (y*20) + .gridPosY, 20, 20, .grid(x,y).fclr )

				end if

			next

		next

		DrawText( "NEXT", .gridPosX + .gridSizeX*20 + 50, .gridPosY, 20, DARKGRAY )

		if .checkLines = 0 then

			for y as integer = 0 to 3

				for x as integer = 0 to 3

					if world.curShape.block(x, y).ID <> 0 then

						DrawRectangle( (x*20) + .gridPosX + (.curShapePosX*20), (y*20) + .gridPosY + (.curShapePosY*20), 20, 20, .curShape.block(x, y).bclr )
						DrawRectangleLines( (x*20) + .gridPosX + (.curShapePosX*20), (y*20) + .gridPosY + (.curShapePosY*20), 20, 20, .curShape.block(x, y).fclr )

					end if

				next

			next

		end if


		for y as integer = 0 to 5

			for x as integer = 0 to 5

				if x<4 and y<4 then

					if world.nextShape.block(x, y).ID <> 0 then

						DrawRectangle( (x+1)*20 + .gridPosX + (.gridSizeX+1)*20, (y+1)*20 + .gridPosY, 20, 20, .nextShape.block(x, y).bclr )
						DrawRectangleLines( (x+1)*20 + .gridPosX + (.gridSizeX+1)*20, (y+1)*20 + .gridPosY, 20, 20, .curShape.block(x, y).fclr )

					end if

				end if

			next

		next


		if .checkLines = 2 then

			dim as byte flasher = 128+127*sin(curTime*50)

			for i as integer = 0 to .destructCount-1

				dim as integer y = .destructMark(i)

				for x as integer = 1 to .gridSizeX-1

					DrawRectangle( (x*20) + .gridPosX, (y*20) + .gridPosY, 20, 20, color( flasher, 0, 0, 255) )
					DrawRectangleLines( (x*20) + .gridPosX, (y*20) + .gridPosY, 20, 20, color( flasher, flasher, 0, 255) )
					
				next

			next

		end if

		if .isPaused then

			dim as byte flasher = 128+127*sin(curTime*5)

			DrawText( "PAUSED", .gridPosX + (.gridSizeX\2)*20-90, .gridPosY+(.gridSizeY\2)*20, 50, color( flasher, flasher, flasher, 255) )

		end if

		dim as Camera2D cam
		.particles.render(cam)

		EndDrawing()

		.soundSys.update()

		.particles.update(deltaTime)

		sleep 3,1

	loop until WindowShouldClose()

end with


world.terminate()
