#include once "particle.bi"


operator rgb_struct.cast() as uinteger

	if r<0 then r = 0
	if g<0 then g = 0
	if b<0 then b = 0

	if r>255 then r = 255
	if g>255 then g = 255
	if b>255 then b = 255

	return rgb(r,g,b)

end operator

constructor rgb_struct()

end constructor

constructor rgb_struct( byref r as integer, byref g as integer, byref b as integer )

this.r = r
this.g = g
this.b = b

end constructor


constructor rgb_struct( byref nCol as rgb_struct )

this.r = nCol.r
this.g = nCol.g
this.b = nCol.b

end constructor


sub particle_system.render( byref cam as camera2D )
	
	for i as integer = ubound(parts) to 0 step-1

		with parts(i)

			if .active then
				
				dim as vec2f zP = .p' * cdbl(cam.zoom)

				select case as const .pType

					case PARTICLE_ENUM.EXPLOSION

						dim as vec2f dl = .v
						dim as mFloat mag = dl.magnitude()*2
						dl.normalize
						'line(zP.x, zP.y)-((zP.x+dl.x*mag)-cam.p.x, (zP.y+dl.y*mag)-cam.p.y),.colour
						DrawLine(  .p.x, .p.y, .p.x+dl.x*mag, .p.y+dl.y*mag, color(.colour.r, .colour.g, .colour.b, 128) )
						dim as mFloat scalar = .size/20
						DrawTexturePro( .sprite, Rectangle(0,0, .sprite.width, .sprite.height), Rectangle( .p.x, .p.y, .sprite.width*scalar, .sprite.height*scalar), Vector2( (.sprite.width*scalar)\2, (.sprite.height*scalar)\2), .rot, color( .colour.r, .colour.g, .colour.b, 64 ) )
						
					case PARTICLE_ENUM.THRUST

						dim as vec2f dl = .v
						dim as mFloat mag = dl.magnitude()*.05
						dl.normalize
						'line( (zP.x-dl.x*mag)-cam.p.x, (zP.y-dl.y*mag)-cam.p.y)-( (zP.x+dl.x*mag)-cam.p.x,(zP.y+dl.y*mag)-cam.p.y),.colour
						'circle(zP.x-cam.p.x, zP.y-cam.p.y), .size, .colour

						dim as integer alphaCol = .colour.r
						if alphaCol<0 then alphaCol = 0
						if alphaCol>255 then alphaCol = 255

						'rotozoom_alpha2( 0, .sprite, zP.x-cam.p.x, zP.y-cam.p.y, int(.rot), .size/20,,&h00000000,alphaCol )
						'rotozoom_alpha( , .sprite, zP.x-cam.p.x, zP.y-cam.p.y, int(.rot), .size/40,.size/40,&hffff00ff )
						dim as mFloat scalar = .size/5
						DrawTexturePro( .sprite, Rectangle(0,0, .sprite.width, .sprite.height), Rectangle( .p.x, .p.y, .sprite.width*scalar, .sprite.height*scalar), Vector2( (.sprite.width*scalar)\2, (.sprite.height*scalar)\2), .rot, color( .colour.r, .colour.g, .colour.b, 64 ) )
						

					case PARTICLE_ENUM.PING

						if .size=0 then .size = 1

						for s as mFloat = .size/2 to .size step .size/4

							circle(zP.x, zP.y), s, .colour,.rot-.5,.rot+.5

						next


					case PARTICLE_ENUM.SHIELD

						'dim as vec2f p1 = .p-cam.p
						'dim as vec2f p2 = .pb-cam.p

						'line(p1.x, p1.y)-(p2.x, p2.y),.colour,,&b1100110011001100

				end select

			end if

		end with

	next

end sub


sub particle_system.init( byref cnt as integer )

	redim parts(cnt)

end sub


sub particle_system.update( byref tDelta as mFloat )

	dim as double cTime = timer

	for i as integer = 0 to ubound(parts)

		with parts(i)

			if .active then

				select case as const .pType


					case PARTICLE_ENUM.EXPLOSION

						.p+=.v*(tDelta*50)
						.v += .v*(.vDecay*tDelta)

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if


					case PARTICLE_ENUM.THRUST

						.p+=(.v*(tDelta))
						.v += (.v*(.vDecay*tDelta))

						.size+=(.sizeDelta*tDelta)

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if


					case PARTICLE_ENUM.PING

						.size += (.sizeDelta*tDelta)
						if .size>.sizeMax then
							.active = false
						end if


					case PARTICLE_ENUM.SHIELD

						.p+=(.v*(tDelta*5))
						.pb+=(.v*(tDelta*5))

						.v += (.v*(.vDecay*tDelta))

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if



				end select

			end if

		end with

	next

end sub


sub particle_system.spawn_shield(byref sp as vec2f, byref ep as vec2f, byref vel as vec2f )

	'dim as vec2f mp = (sp+ep)/2
	'dim as vec2f perp = ep.perp(sp)
	'perp.Normalize()

	'static as integer cntr

	'cntr+=1
	'if cntr>10 then cntr = 0

	'for i as integer = 0 to ubound(parts)

	'	with parts(i)

	'		if not .active then

	'			.active = true
	'			.lSpan = timer+.025
	'			.p = sp
	'			.pb = ep
	'			.v = perp*(50+cntr)
	'			.colour = rgb_struct(0,0,255)
	'			.colDelta = rgb_struct(10000,10000,0)
	'			.vDecay = -5.59
	'			.pType = PARTICLE_ENUM.SHIELD

	'			exit sub

	'		end if

	'	end with

	'next

end sub


sub particle_system.spawn_explosion( byref posit as vec2f, byref mag as mFloat, byref maxParts as integer = 19, byref partType as PARTICLE_ENUM, byref sprite as Texture2D, byref lifeSpan as mFloat )
	
	for ri as integer = 0 to maxParts

		dim as mFloat radian = ri * ( PI2 / (maxParts+1) )
		
		dim as mFloat randRad = rnd*2
		
		for ti as integer = 0 to ubound(parts)

			with parts(ti)

				if not .active then
					.active = true
					.p = posit + vec2f(3*sin(radian+randRad), 3*cos(radian+randRad))
					.v = vec2f(sin(radian+randRad), cos(radian+randRad))*(mag+rnd*(mag*8))
					.lSpan = lifeSpan
					.pType = PARTICLE_ENUM.EXPLOSION
					.sprite = sprite
					
					.colour = rgb_struct(255, 255, 0)
					.colDelta = rgb_struct(-510, -510, 0)
					.vDecay = -5.59
					exit for
				end if

			end with

		next

	next

end sub


sub particle_system.spawn_ping( byref posit as vec2f, byref radDelta as mFloat, byref ang as mFloat, byref partType as PARTICLE_ENUM )


	for ti as integer = 0 to ubound(parts)

		with parts(ti)

			if not .active then

				.active = true
				.p = posit
				.lSpan = timer+2
				'.pType = PARTICLE_ENUM.PING
				'.sprite = sprite
				.colour = type(255, 255, 0)
				.vDecay = 0
				.size = 0
				.sizeDelta = 200
				.sizeMax = 50
				.rot = ang

				exit sub

			end if

		end with

	next


end sub


sub particle_system.spawn_thrust( byref posit as vec2f, byref vel as vec2f, byref ang as mFloat, byref sprite as Texture2D, byref lifeSpan as mFloat)

	static as vec2f endVec, randPoint
	static as mFloat dist
	static as mFloat randDist

	for ti as integer = 0 to ubound(parts)
		with parts(ti)

			if not .active then
				
				randPoint = posit
				
				.rot = ang
				.active = true
				.p = randPoint
				.v = vel
				.lSpan = lifeSpan
				.sprite = sprite
				.pType = PARTICLE_ENUM.THRUST
				.colour = rgb_struct(128, 128, 255)
				.colDelta = rgb_struct(-100,-210, 300)
				.vDecay = 0
				.size = rnd*.5
				.sizeDelta = 40
				
				exit sub
				
			end if

		end with
	next

end sub