#include once "sound.bi"

constructor sound_system()

	fbs_Set_PlugPath("./lib/")

	fbs_Init()

end constructor


destructor sound_system()

end destructor


sub sound_bank.follow()

	p.x = followHost->x
	p.y = followHost->y

end sub


function sound_source.set_follow_host( byval toFollow as vec2f ptr, byref id as integer = 0  ) as byte

	if toFollow <> 0 then

		if id < 0 then

			for sB  as integer = 0 to ubound(soundBank)

				with soundBank(sB)

					.followHost = toFollow

					.following = true

				end with

			next

			return true

		else

			with soundBank(id)

				.followHost = toFollow

				.following = true

			end with

			return true

		end if

	else

		return false

	end if

end function


sub sound_system.unload_all()
	
	for i as integer = 0 to ubound( source )
	
		with source( i )
			
			for sb as integer = 0 to ubound(.soundbank)
			
				fbs_Destroy_Sound( @.soundBank(sb).sound )
				
			next
			
			erase .soundbank
			
		end with
		
	next
	
	for i as integer = 0 to ubound( soundFile )
	
		with soundFile( i )
		
			fbs_Destroy_Wave( @.wav ) 
		
		end with
		
	next
	
	erase soundFile
	erase source
	
end sub


function sound_system.add_source( byref wavId as integer, byref count as integer, byref nam as string = "sound" ) as uinteger

	static as integer top

	top = ubound(source) + 1

	redim preserve source( top )

	with source( top )

		.sName = nam

		redim preserve .soundBank(count)

		for i as integer = 0 to ubound(.soundBank)

			fbs_Create_Sound( wavID, @.soundBank(i).sound)

		next

		print .sName & " source added!"

	end with

	return top

end function


sub sound_system.update()

	static as integer nLoops, dx, dy

	static as single pan, vol

	for s as integer = 0 to ubound(source)

		with source(s)

			for sB as integer =  0 to ubound(.soundBank)

				with .soundBank(sB)

					fbs_Get_SoundLoops(.sound, @nLoops)

					if nLoops>0 then

						if .following then

							.follow()

						end if

						dx = .p.x - p.x
						dy = .p.y - p.y

						vol = 2 - (dx*dx+dy*dy) / DIST_FALLOFF

						if .vol <> vol then

							fbs_Set_SoundVolume (.sound, vol)
							.vol = vol

						end if

						pan = abs(dx) / PAN_FALLOFF

						if .pan <> pan then

							fbs_Set_SoundPan (.sound, pan)
							.pan = pan

						end if

					end if


					if .inQueue then

						.inQueue = false
						fbs_Play_Sound ( .sound, .loops )

					end if

				end with

			next

		end with

	next

end sub


sub sound_system.play_source( byref id as integer, byref loops as integer )

	static as integer nLoops

	static as single pan, vol

	static as vec2f sP

	with source(id)

		sP = .p

		for sB as integer = 0 to ubound(.soundBank)

			with .soundBank(sB)

				fbs_Get_SoundLoops( .sound, @nLoops )

				if nLoops = 0 then

					.p = sP
					.inQueue = true
					.loops = loops
					
					'print "Playing sound"
					
					exit sub

				end if

			end with

		next

	end with

end sub


function sound_system.load_wav( byref fName as string ) as uinteger

	static as integer top

	top = ubound(soundFile)+1

	redim preserve soundFile(top)

	soundFile(top).sName = fName

	if fbs_Load_WAVFile ( fName, @soundFile(top).wav ) then
		
		print soundFile(top).sName & " loaded successfully"
		
	end if

	return top

end function


sub sound_system.set_listener_position( byref position as vec2f )

	p = position

end sub


function sound_system.get_listener_position() as vec2f

	return p

end function


sub sound_system.set_source_position ( byref id as integer, byref position as vec2f )

	source(id).p = position

end sub


sub sound_system.set_source_pause( byref id as integer, byref state as boolean, byref bankID as integer = 0 )

	static as boolean toggle
	
	with source(id).soundBank(bankID)
	
		fbs_Get_SoundPaused( .sound, @toggle ) 
	
		if state<>toggle then
	
			fbs_Set_SoundPaused( .sound, state )
	
		end if
	
	end with

end sub


function sound_system.load_song( byref fName as string ) as uinteger
	
	static as integer top

	top = ubound(musicFile)+1

	redim preserve musicFile(top)

	musicFile(top).sName = fName
	
	fbs_Load_MP3File( fName, @musicFile(top).wav )
	
	print musicFile(top).sName & " loaded successfully"

	return top
	
end function


sub sound_system.play_song( byref id as uinteger, byref loops as integer )
	
	music.soundBank = musicFile(id).wav
	
	fbs_Play_Wave( music.soundBank, loops, 1, 5 )
	
end sub